<?php
/**
 *
 * @package	    Pay My Bill Module
 * @subpackage	Pay My Bill Module
 * @version     1.0.0
 * @description Pay My Bill Module
 * @copyright	  Copyright © 2013 - All rights reserved.
 * @license		  GNU General Public License v2.0
 * @author		  SoftPill.Eu
 * @author mail	mail@softpill.eu
 * @website		  www.softpill.eu
 *
 */
//ini_set("display_errors",0);
//error_reporting(E_ALL);

if (version_compare(PHP_VERSION, '5.3.1', '<'))
{
	die('Your host needs to use PHP 5.3.1 or higher to run this version of Joomla!');
}
define('_JEXEC', 1);
defined( '_JEXEC' ) or die( 'Restricted access' );
define('DS', DIRECTORY_SEPARATOR);
$dirname=str_ireplace(DS.'modules'.DS.'mod_paymybill'.DS.'return','', dirname(__FILE__));

if (file_exists($dirname.DS.'defines.php'))
{
	include_once $dirname.DS.'defines.php';
}
if (!defined('_JDEFINES'))
{
	define('JPATH_BASE', $dirname);
	require_once JPATH_BASE.DS.'includes/defines.php';
}
require_once JPATH_BASE.DS.'includes/framework.php';
// Mark afterLoad in the profiler.
JDEBUG ? $_PROFILER->mark('afterLoad') : null;
// Instantiate the application.
$app = JFactory::getApplication('site');

$lang = JFactory::getLanguage();
$extension = 'mod_paymybill';
$language_tag = $lang->getTag();
$reload = true;
$lang->load($extension, $dirname, $language_tag, $reload);

require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."helper.php");
$PMBHelper = new PMBHelper();

$session_id=isset($_POST['REFNOEXT'])?$_POST['REFNOEXT']:"";

if($session_id=="")
  exit;

$module_id=0;
$tarr=explode("-",$session_id);
$module_id=$tarr[1]+0;
if($module_id==0)
  exit;
$order_paid=0;
$params=$PMBHelper->getWorkingModParams($module_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."functions".DS."functions.php");
$pmbf=new PMBFunctions();
$details=$pmbf->getOrderDetails($session_id);
require_once(JPATH_BASE.DS."modules".DS."mod_paymybill".DS."methods".DS."payuturkey.php");
$LiveUpdateModPayU=new LiveUpdateModPayU();

ini_set("mbstring.func_overload", 0);
if(ini_get("mbstring.func_overload") > 2){  /* check if mbstring.func_overload is still set to overload strings(2)*/
$pmbf->sendMailtoAdmin("WARNING: mbstring.func_overload is set to overload strings and might cause problems\n",' - PayU Warning!');
}

$pass		= $params['payuturkey_password'];	/* pass to compute HASH */
$result		= ""; 				/* string for compute HASH for received data */
$return		= ""; 				/* string to compute HASH for return result */
$signature	= $_POST['HASH'];	/* HASH received */

while(list($key, $val) = each($_POST)){
	$$key=$val;
	if($key != "HASH"){
		if(is_array($val)) $result .= $LiveUpdateModPayU->ArrayExpand($val);
		else{
			$size		= strlen(StripSlashes($val));
			$result	.= $size.StripSlashes($val);
		}
	}
}

$date_return = date("YmdHis");

$return = strlen($_POST["IPN_PID"][0]).$_POST["IPN_PID"][0].strlen($_POST["IPN_PNAME"][0]).$_POST["IPN_PNAME"][0];
$return .= strlen($_POST["IPN_DATE"]).$_POST["IPN_DATE"].strlen($date_return).$date_return;
$hash =  $LiveUpdateModPayU->hmac($pass, $result); /* HASH for data received */
$order_paid=0;
//print_r($_POST);
$ORDERSTATUS=$_POST['ORDERSTATUS'];
if($ORDERSTATUS=='COMPLETE' || $ORDERSTATUS=='PAYMENT_AUTHORIZED' || $ORDERSTATUS=='TEST'){
    $result_hash =  $LiveUpdateModPayU->hmac($pass, $return);
    $order_paid=1;
    ob_clean();
  	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
}
else if($ORDERSTATUS=='REFUND'){
  $result_hash =  $LiveUpdateModPayU->hmac($pass, $return);
  ob_clean();
	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
  exit;
}

$method_name='PayuTurkey';

$message="";
$message2="";

if($order_paid == 1)
{
  //send mail
  if($params['mail_success']!=0)
  {
    $pmbf->sendConfirmationMail('success',$params,$details,$method_name);
  }
  $pmbf->setOrderSuccess($params,$details,$method_name);
}
else
{
  //send mail
  if($params['mail_cancelled']!=0)
  {
    $pmbf->sendConfirmationMail('cancelled',$params,$details,$method_name);
  }
  $pmbf->setOrderCancelled($params,$details,$method_name);
}
exit;
?>
